--- php-8.4.18/sapi/cgi/Makefile.frag	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/sapi/cgi/Makefile.frag	2026-04-01 04:35:36.023945498 +0000
@@ -6,7 +6,7 @@
 install-cgi: $(SAPI_CGI_PATH)
 	@echo "Installing PHP CGI binary:        $(INSTALL_ROOT)$(bindir)/"
 	@$(mkinstalldirs) $(INSTALL_ROOT)$(bindir)
-	@$(INSTALL) -m 0755 $(SAPI_CGI_PATH) $(INSTALL_ROOT)$(bindir)/$(program_prefix)php-cgi$(program_suffix)$(EXEEXT)
+	@$(LIBTOOL) --mode=install $(INSTALL) -m 0755 $(SAPI_CGI_PATH) $(INSTALL_ROOT)$(bindir)/$(program_prefix)php-cgi$(program_suffix)$(EXEEXT)
 	@echo "Installing PHP CGI man page:      $(INSTALL_ROOT)$(mandir)/man1/"
 	@$(mkinstalldirs) $(INSTALL_ROOT)$(mandir)/man1
 	@$(INSTALL_DATA) sapi/cgi/php-cgi.1 $(INSTALL_ROOT)$(mandir)/man1/$(program_prefix)php-cgi$(program_suffix).1
diff '--color=auto' -Naur php-8.4.18/sapi/cli/Makefile.frag php-8.4.20RC1/sapi/cli/Makefile.frag
--- php-8.4.18/sapi/cli/Makefile.frag	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/sapi/cli/Makefile.frag	2026-04-01 04:35:36.024028806 +0000
@@ -6,7 +6,7 @@
 install-cli: $(SAPI_CLI_PATH)
 	@echo "Installing PHP CLI binary:        $(INSTALL_ROOT)$(bindir)/"
 	@$(mkinstalldirs) $(INSTALL_ROOT)$(bindir)
-	@$(INSTALL) -m 0755 $(SAPI_CLI_PATH) $(INSTALL_ROOT)$(bindir)/$(program_prefix)php$(program_suffix)$(EXEEXT)
+	@$(LIBTOOL) --mode=install $(INSTALL) -m 0755 $(SAPI_CLI_PATH) $(INSTALL_ROOT)$(bindir)/$(program_prefix)php$(program_suffix)$(EXEEXT)
 	@echo "Installing PHP CLI man page:      $(INSTALL_ROOT)$(mandir)/man1/"
 	@$(mkinstalldirs) $(INSTALL_ROOT)$(mandir)/man1
 	@$(INSTALL_DATA) sapi/cli/php.1 $(INSTALL_ROOT)$(mandir)/man1/$(program_prefix)php$(program_suffix).1
diff '--color=auto' -Naur php-8.4.18/sapi/fpm/Makefile.frag php-8.4.20RC1/sapi/fpm/Makefile.frag
--- php-8.4.18/sapi/fpm/Makefile.frag	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/sapi/fpm/Makefile.frag	2026-04-01 04:35:36.024117563 +0000
@@ -8,7 +8,7 @@
 	@$(mkinstalldirs) $(INSTALL_ROOT)$(sbindir)
 	@$(mkinstalldirs) $(INSTALL_ROOT)$(localstatedir)/log
 	@$(mkinstalldirs) $(INSTALL_ROOT)$(localstatedir)/run
-	@$(INSTALL) -m 0755 $(SAPI_FPM_PATH) $(INSTALL_ROOT)$(sbindir)/$(program_prefix)php-fpm$(program_suffix)$(EXEEXT)
+	@$(LIBTOOL) --mode=install $(INSTALL) -m 0755 $(SAPI_FPM_PATH) $(INSTALL_ROOT)$(sbindir)/$(program_prefix)php-fpm$(program_suffix)$(EXEEXT)
 
 	@if test -f "$(INSTALL_ROOT)$(sysconfdir)/php-fpm.conf"; then \
 		echo "Installing PHP FPM defconfig:     skipping"; \
diff '--color=auto' -Naur php-8.4.18/sapi/fpm/tests/bug77023-pm-dynamic-blocking-sigquit.phpt php-8.4.20RC1/sapi/fpm/tests/bug77023-pm-dynamic-blocking-sigquit.phpt
--- php-8.4.18/sapi/fpm/tests/bug77023-pm-dynamic-blocking-sigquit.phpt	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/sapi/fpm/tests/bug77023-pm-dynamic-blocking-sigquit.phpt	2026-04-01 04:35:36.024195120 +0000
@@ -6,7 +6,7 @@
 <?php
 include "skipif.inc";
 if (!function_exists('pcntl_sigprocmask')) die('skip Requires pcntl_sigprocmask()');
-if (!getenv("FPM_RUN_RESOURCE_HEAVY_TESTS")) die("skip resource heavy test");
+if (!getenv("RUN_RESOURCE_HEAVY_TESTS")) die("skip resource-heavy test");
 if (getenv('SKIP_SLOW_TESTS')) die('skip slow tests excluded by request');
 ?>
 --FILE--
diff '--color=auto' -Naur php-8.4.18/sapi/fpm/tests/proc-idle-timeout.phpt php-8.4.20RC1/sapi/fpm/tests/proc-idle-timeout.phpt
--- php-8.4.18/sapi/fpm/tests/proc-idle-timeout.phpt	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/sapi/fpm/tests/proc-idle-timeout.phpt	2026-04-01 04:35:36.024264511 +0000
@@ -3,7 +3,7 @@
 --SKIPIF--
 <?php
 include "skipif.inc";
-if (!getenv("FPM_RUN_RESOURCE_HEAVY_TESTS")) die("skip resource heavy test");
+if (!getenv("FPM_RUN_RESOURCE_HEAVY_TESTS")) die("skip FPM resource-heavy test");
 if (getenv("SKIP_SLOW_TESTS")) die("skip slow test");
 ?>
 --FILE--
diff '--color=auto' -Naur php-8.4.18/sapi/litespeed/Makefile.frag php-8.4.20RC1/sapi/litespeed/Makefile.frag
--- php-8.4.18/sapi/litespeed/Makefile.frag	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/sapi/litespeed/Makefile.frag	2026-04-01 04:35:36.024338942 +0000
@@ -6,4 +6,4 @@
 install-litespeed: $(SAPI_LITESPEED_PATH)
 	@echo "Installing PHP LiteSpeed binary:  $(INSTALL_ROOT)$(bindir)/"
 	@$(mkinstalldirs) $(INSTALL_ROOT)$(bindir)
-	@$(INSTALL) -m 0755 $(SAPI_LITESPEED_PATH) $(INSTALL_ROOT)$(bindir)/$(program_prefix)lsphp$(program_suffix)
+	@$(LIBTOOL) --mode=install $(INSTALL) -m 0755 $(SAPI_LITESPEED_PATH) $(INSTALL_ROOT)$(bindir)/$(program_prefix)lsphp$(program_suffix)
diff '--color=auto' -Naur php-8.4.18/sapi/phpdbg/Makefile.frag php-8.4.20RC1/sapi/phpdbg/Makefile.frag
--- php-8.4.18/sapi/phpdbg/Makefile.frag	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/sapi/phpdbg/Makefile.frag	2026-04-01 04:35:36.024411639 +0000
@@ -25,7 +25,7 @@
 	@$(mkinstalldirs) $(INSTALL_ROOT)$(bindir)
 	@$(mkinstalldirs) $(INSTALL_ROOT)$(localstatedir)/log
 	@$(mkinstalldirs) $(INSTALL_ROOT)$(localstatedir)/run
-	@$(INSTALL) -m 0755 $(BUILD_BINARY) $(INSTALL_ROOT)$(bindir)/$(program_prefix)phpdbg$(program_suffix)$(EXEEXT)
+	@$(LIBTOOL) --mode=install $(INSTALL) -m 0755 $(BUILD_BINARY) $(INSTALL_ROOT)$(bindir)/$(program_prefix)phpdbg$(program_suffix)$(EXEEXT)
 	@echo "Installing phpdbg man page:       $(INSTALL_ROOT)$(mandir)/man1/"
 	@$(mkinstalldirs) $(INSTALL_ROOT)$(mandir)/man1
 	@$(INSTALL_DATA) sapi/phpdbg/phpdbg.1 $(INSTALL_ROOT)$(mandir)/man1/$(program_prefix)phpdbg$(program_suffix).1
diff '--color=auto' -Naur php-8.4.18/sapi/phpdbg/phpdbg_utils.c php-8.4.20RC1/sapi/phpdbg/phpdbg_utils.c
--- php-8.4.18/sapi/phpdbg/phpdbg_utils.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/sapi/phpdbg/phpdbg_utils.c	2026-04-01 04:35:36.024539501 +0000
@@ -111,7 +111,7 @@
 
 PHPDBG_API int phpdbg_is_class_method(const char *str, size_t len, char **class, char **method) /* {{{ */
 {
-	char *sep = NULL;
+	const char *sep = NULL;
 
 	if (strstr(str, "#") != NULL)
 		return 0;
diff '--color=auto' -Naur php-8.4.18/scripts/gdb/debug_gdb_scripts_gen.php php-8.4.20RC1/scripts/gdb/debug_gdb_scripts_gen.php
--- php-8.4.18/scripts/gdb/debug_gdb_scripts_gen.php	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/scripts/gdb/debug_gdb_scripts_gen.php	2026-04-01 04:35:36.024705825 +0000
@@ -27,7 +27,7 @@
      *
      * See https://sourceware.org/gdb/current/onlinedocs/gdb.html/dotdebug_005fgdb_005fscripts-section.html#dotdebug_005fgdb_005fscripts-section
      */
-    asm(
+    __asm__(
         ".pushsection \".debug_gdb_scripts\", \"MS\",%%progbits,1\n"
         ".byte 4 /* Python Text */\n"
         ".ascii \"gdb.inlined-script\\n\"\n"
diff '--color=auto' -Naur php-8.4.18/Zend/Optimizer/sccp.c php-8.4.20RC1/Zend/Optimizer/sccp.c
--- php-8.4.18/Zend/Optimizer/sccp.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/Zend/Optimizer/sccp.c	2026-04-01 04:35:35.982880787 +0000
@@ -965,7 +965,7 @@
 					SET_RESULT(op1, &zv);
 				} else if (ct_eval_assign_dim(&zv, data, op2) == SUCCESS) {
 					/* Mark array containing partial array as partial */
-					if (IS_PARTIAL_ARRAY(data)) {
+					if (IS_PARTIAL_ARRAY(data) || IS_PARTIAL_OBJECT(data)) {
 						MAKE_PARTIAL_ARRAY(&zv);
 					}
 					SET_RESULT(result, data);
@@ -1165,7 +1165,7 @@
 						/* We can't add NEXT element into partial array (skip it) */
 						SET_RESULT(result, &zv);
 					} else if (ct_eval_add_array_elem(&zv, op1, op2) == SUCCESS) {
-						if (IS_PARTIAL_ARRAY(op1)) {
+						if (IS_PARTIAL_ARRAY(op1) || IS_PARTIAL_OBJECT(op1)) {
 							MAKE_PARTIAL_ARRAY(&zv);
 						}
 						SET_RESULT(result, &zv);
diff '--color=auto' -Naur php-8.4.18/Zend/Optimizer/zend_optimizer.c php-8.4.20RC1/Zend/Optimizer/zend_optimizer.c
--- php-8.4.18/Zend/Optimizer/zend_optimizer.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/Zend/Optimizer/zend_optimizer.c	2026-04-01 04:35:35.983065166 +0000
@@ -799,6 +799,9 @@
 	zend_class_entry *ce = Z_PTR_P(ce_zv);
 
 	if (ce->ce_flags & ZEND_ACC_PRELOADED) {
+		if (CG(compiler_options) & ZEND_COMPILE_WITH_FILE_CACHE) {
+			return true;
+		}
 		Bucket *ce_bucket = (Bucket*)((uintptr_t)ce_zv - XtOffsetOf(Bucket, val));
 		size_t offset = ce_bucket - EG(class_table)->arData;
 		if (offset < EG(persistent_classes_count)) {
@@ -817,6 +820,9 @@
 		return false;
 	} else if (fbc->type == ZEND_USER_FUNCTION) {
 		if (fbc->op_array.fn_flags & ZEND_ACC_PRELOADED) {
+			if (CG(compiler_options) & ZEND_COMPILE_WITH_FILE_CACHE) {
+				return true;
+			}
 			Bucket *fbc_bucket = (Bucket*)((uintptr_t)fbc_zv - XtOffsetOf(Bucket, val));
 			size_t offset = fbc_bucket - EG(function_table)->arData;
 			if (offset < EG(persistent_functions_count)) {
diff '--color=auto' -Naur php-8.4.18/Zend/tests/bug55509.phpt php-8.4.20RC1/Zend/tests/bug55509.phpt
--- php-8.4.18/Zend/tests/bug55509.phpt	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/Zend/tests/bug55509.phpt	2026-04-01 04:35:35.983230999 +0000
@@ -2,6 +2,7 @@
 Bug #55509 (segfault on x86_64 using more than 2G memory)
 --SKIPIF--
 <?php
+if (!getenv('RUN_RESOURCE_HEAVY_TESTS')) die('skip resource-heavy test');
 if (PHP_INT_SIZE == 4) {
   die('skip Not for 32-bits OS');
 }
diff '--color=auto' -Naur php-8.4.18/Zend/tests/bug74093.phpt php-8.4.20RC1/Zend/tests/bug74093.phpt
--- php-8.4.18/Zend/tests/bug74093.phpt	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/Zend/tests/bug74093.phpt	2026-04-01 04:35:35.983304207 +0000
@@ -1,7 +1,9 @@
 --TEST--
 Bug #74093 (Maximum execution time of n+2 seconds exceed not written in error_log)
+--FLAKY--
 --SKIPIF--
 <?php
+if (!getenv('RUN_RESOURCE_HEAVY_TESTS')) die('skip resource-heavy test');
 if (getenv("SKIP_SLOW_TESTS")) die("skip slow test");
 if (PHP_ZTS) die("skip only for no-zts build");
 if (substr(PHP_OS, 0, 3) == 'WIN') die("skip not for Windows");
@@ -12,8 +14,8 @@
 hard_timeout=1
 --FILE--
 <?php
-$a1 = range(1, 2000000);
-$a2 = range(100000, 2999999);
+$a1 = range(1, 3000000);
+$a2 = range(100000, 3999999);
 array_intersect($a1, $a2);
 ?>
 --EXPECTF--
diff '--color=auto' -Naur php-8.4.18/Zend/tests/bug78010.phpt php-8.4.20RC1/Zend/tests/bug78010.phpt
--- php-8.4.18/Zend/tests/bug78010.phpt	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/Zend/tests/bug78010.phpt	2026-04-01 04:35:35.983380571 +0000
@@ -2,6 +2,7 @@
 Bug #78010: Segmentation fault during GC
 --SKIPIF--
 <?php
+if (!getenv('RUN_RESOURCE_HEAVY_TESTS')) die('skip resource-heavy test');
 if (getenv("SKIP_SLOW_TESTS")) die('skip slow test');
 ?>
 --INI--
diff '--color=auto' -Naur php-8.4.18/Zend/tests/lazy_objects/gh20504-001.phpt php-8.4.20RC1/Zend/tests/lazy_objects/gh20504-001.phpt
--- php-8.4.18/Zend/tests/lazy_objects/gh20504-001.phpt	1970-01-01 00:00:00.000000000 +0000
+++ php-8.4.20RC1/Zend/tests/lazy_objects/gh20504-001.phpt	2026-04-01 04:35:35.983491441 +0000
@@ -0,0 +1,24 @@
+--TEST--
+GH-20504: Assertion failure in zend_get_property_guard() when lazy proxy adds magic method - isset
+--CREDITS--
+vi3tL0u1s
+--FILE--
+<?php
+
+class RealInstance {
+    public $_;
+}
+class Proxy extends RealInstance {
+    public function __isset($name) {
+        return isset($this->$name['']);
+    }
+}
+$rc = new ReflectionClass(Proxy::class);
+$obj = $rc->newLazyProxy(function () {
+    return new RealInstance;
+});
+var_dump(isset($obj->name['']));
+
+?>
+--EXPECT--
+bool(false)
diff '--color=auto' -Naur php-8.4.18/Zend/tests/lazy_objects/gh20504-002.phpt php-8.4.20RC1/Zend/tests/lazy_objects/gh20504-002.phpt
--- php-8.4.18/Zend/tests/lazy_objects/gh20504-002.phpt	1970-01-01 00:00:00.000000000 +0000
+++ php-8.4.20RC1/Zend/tests/lazy_objects/gh20504-002.phpt	2026-04-01 04:35:35.983562555 +0000
@@ -0,0 +1,23 @@
+--TEST--
+GH-20504: Assertion failure in zend_get_property_guard() when lazy proxy adds magic method - get
+--FILE--
+<?php
+
+class RealInstance {
+    public $_;
+}
+class Proxy extends RealInstance {
+    public function __get($name) {
+        return $this->$name;
+    }
+}
+$rc = new ReflectionClass(Proxy::class);
+$obj = $rc->newLazyProxy(function () {
+    return new RealInstance;
+});
+var_dump($obj->name);
+
+?>
+--EXPECTF--
+Warning: Undefined property: RealInstance::$name in %s on line %d
+NULL
diff '--color=auto' -Naur php-8.4.18/Zend/tests/lazy_objects/gh20504-003.phpt php-8.4.20RC1/Zend/tests/lazy_objects/gh20504-003.phpt
--- php-8.4.18/Zend/tests/lazy_objects/gh20504-003.phpt	1970-01-01 00:00:00.000000000 +0000
+++ php-8.4.20RC1/Zend/tests/lazy_objects/gh20504-003.phpt	2026-04-01 04:35:35.983634261 +0000
@@ -0,0 +1,33 @@
+--TEST--
+GH-20504: Assertion failure in zend_get_property_guard() when lazy proxy adds magic method - set
+--FILE--
+<?php
+
+#[AllowDynamicProperties]
+class RealInstance {
+    public $_;
+}
+class Proxy extends RealInstance {
+    public function __set($name, $value) {
+        $this->$name = $value;
+    }
+}
+$rc = new ReflectionClass(Proxy::class);
+$obj = $rc->newLazyProxy(function () {
+    return new RealInstance;
+});
+$obj->name = 0;
+
+var_dump($obj);
+
+?>
+--EXPECTF--
+lazy proxy object(Proxy)#%d (1) {
+  ["instance"]=>
+  object(RealInstance)#%d (2) {
+    ["_"]=>
+    NULL
+    ["name"]=>
+    int(0)
+  }
+}
diff '--color=auto' -Naur php-8.4.18/Zend/tests/lazy_objects/gh20504-004.phpt php-8.4.20RC1/Zend/tests/lazy_objects/gh20504-004.phpt
--- php-8.4.18/Zend/tests/lazy_objects/gh20504-004.phpt	1970-01-01 00:00:00.000000000 +0000
+++ php-8.4.20RC1/Zend/tests/lazy_objects/gh20504-004.phpt	2026-04-01 04:35:35.983709773 +0000
@@ -0,0 +1,28 @@
+--TEST--
+GH-20504: Assertion failure in zend_get_property_guard() when lazy proxy adds magic method - proxy defines __isset(), both have guards
+--FILE--
+<?php
+
+class RealInstance {
+    public $_;
+    public function __get($name) {
+        printf("%s::%s\n", static::class, __FUNCTION__);
+    }
+}
+class Proxy extends RealInstance {
+    public function __isset($name) {
+        printf("%s::%s\n", static::class, __FUNCTION__);
+        return isset($this->$name['']);
+    }
+}
+$rc = new ReflectionClass(Proxy::class);
+$obj = $rc->newLazyProxy(function () {
+    return new RealInstance;
+});
+var_dump(isset($obj->name['']));
+
+?>
+--EXPECT--
+Proxy::__isset
+Proxy::__get
+bool(false)
diff '--color=auto' -Naur php-8.4.18/Zend/tests/lazy_objects/gh20504-005.phpt php-8.4.20RC1/Zend/tests/lazy_objects/gh20504-005.phpt
--- php-8.4.18/Zend/tests/lazy_objects/gh20504-005.phpt	1970-01-01 00:00:00.000000000 +0000
+++ php-8.4.20RC1/Zend/tests/lazy_objects/gh20504-005.phpt	2026-04-01 04:35:35.983795125 +0000
@@ -0,0 +1,30 @@
+--TEST--
+GH-20504: Assertion failure in zend_get_property_guard() when lazy proxy adds magic method - unset
+--FILE--
+<?php
+
+class RealInstance {
+    public $_;
+}
+class Proxy extends RealInstance {
+    public function __unset($name) {
+        unset($this->$name);
+    }
+}
+$rc = new ReflectionClass(Proxy::class);
+$obj = $rc->newLazyProxy(function () {
+    return new RealInstance;
+});
+unset($obj->name);
+
+var_dump($obj);
+
+?>
+--EXPECTF--
+lazy proxy object(Proxy)#%d (1) {
+  ["instance"]=>
+  object(RealInstance)#%d (1) {
+    ["_"]=>
+    NULL
+  }
+}
diff '--color=auto' -Naur php-8.4.18/Zend/tests/lazy_objects/gh20657-001.phpt php-8.4.20RC1/Zend/tests/lazy_objects/gh20657-001.phpt
--- php-8.4.18/Zend/tests/lazy_objects/gh20657-001.phpt	1970-01-01 00:00:00.000000000 +0000
+++ php-8.4.20RC1/Zend/tests/lazy_objects/gh20657-001.phpt	2026-04-01 04:35:35.983869375 +0000
@@ -0,0 +1,32 @@
+--TEST--
+GH-20657: GC during zend_lazy_object_realize()
+--CREDITS--
+vi3tL0u1s
+--FILE--
+<?php
+
+class C {
+    public $a;
+}
+
+$reflector = new ReflectionClass(C::class);
+
+for ($i = 0; $i < 10000; $i++) {
+    $obj = $reflector->newLazyGhost(function ($obj) {});
+
+    // Add to roots
+    $obj2 = $obj;
+    unset($obj2);
+
+    // Initialize all props to mark object non-lazy. Also create a cycle.
+    $reflector->getProperty('a')->setRawValueWithoutLazyInitialization($obj, $obj);
+}
+
+var_dump($obj);
+
+?>
+--EXPECTF--
+object(C)#%d (1) {
+  ["a"]=>
+  *RECURSION*
+}
diff '--color=auto' -Naur php-8.4.18/Zend/tests/lazy_objects/gh20657-002.phpt php-8.4.20RC1/Zend/tests/lazy_objects/gh20657-002.phpt
--- php-8.4.18/Zend/tests/lazy_objects/gh20657-002.phpt	1970-01-01 00:00:00.000000000 +0000
+++ php-8.4.20RC1/Zend/tests/lazy_objects/gh20657-002.phpt	2026-04-01 04:35:35.983948214 +0000
@@ -0,0 +1,43 @@
+--TEST--
+GH-20657 002: GC during zend_lazy_object_realize() - reset as lazy during realize()
+--FILE--
+<?php
+
+class C {
+    public $a;
+}
+
+class D {
+    public $self;
+    public function __construct() {
+        $this->self = $this;
+    }
+    public function __destruct() {
+        global $obj, $reflector;
+        $reflector->resetAsLazyGhost($obj, function () {});
+    }
+}
+
+new D();
+
+$reflector = new ReflectionClass(C::class);
+
+for ($i = 0; $i < 10000; $i++) {
+    $obj = $reflector->newLazyGhost(function ($obj) {});
+
+    // Add to roots
+    $obj2 = $obj;
+    unset($obj2);
+
+    // Initialize all props to mark object non-lazy. Also create a cycle.
+    $reflector->getProperty('a')->setRawValueWithoutLazyInitialization($obj, $obj);
+}
+
+var_dump($obj);
+
+?>
+--EXPECTF--
+object(C)#%d (1) {
+  ["a"]=>
+  *RECURSION*
+}
diff '--color=auto' -Naur php-8.4.18/Zend/tests/lazy_objects/gh20854.phpt php-8.4.20RC1/Zend/tests/lazy_objects/gh20854.phpt
--- php-8.4.18/Zend/tests/lazy_objects/gh20854.phpt	1970-01-01 00:00:00.000000000 +0000
+++ php-8.4.20RC1/Zend/tests/lazy_objects/gh20854.phpt	2026-04-01 04:35:35.984026121 +0000
@@ -0,0 +1,22 @@
+--TEST--
+GH-20854 (Assertion in ZEND_RETURN_BY_REF with lazy proxy and return-by-ref __get)
+--FILE--
+<?php
+class C {
+    public $prop;
+
+    function &__get($name) {
+        return $this->x;
+    }
+}
+
+$rc = new ReflectionClass(C::class);
+$obj = $rc->newLazyProxy(function () {
+    return new C;
+});
+$obj->x;
+echo "Done\n";
+?>
+--EXPECTF--
+Deprecated: Creation of dynamic property C::$x is deprecated in %s on line %d
+Done
diff '--color=auto' -Naur php-8.4.18/Zend/tests/lazy_objects/gh20873.phpt php-8.4.20RC1/Zend/tests/lazy_objects/gh20873.phpt
--- php-8.4.18/Zend/tests/lazy_objects/gh20873.phpt	1970-01-01 00:00:00.000000000 +0000
+++ php-8.4.20RC1/Zend/tests/lazy_objects/gh20873.phpt	2026-04-01 04:35:35.984096614 +0000
@@ -0,0 +1,30 @@
+--TEST--
+GH-20873 (Assertion failure in _zendi_try_convert_scalar_to_number with lazy proxy)
+--FILE--
+<?php
+class A {
+    public $_;
+    public function __get($n) {
+        global $obj;
+        $obj->x =& $this->_;
+        static $a = $a;
+        $e =& $this->_ - $a;
+    }
+}
+$rc = new ReflectionClass(A::class);
+$obj = $rc->newLazyProxy(fn() => new A);
+$rc->initializeLazyObject($obj);
+var_dump($obj->p);
+?>
+--EXPECTF--
+Deprecated: Creation of dynamic property A::$x is deprecated in %s on line %d
+
+Warning: Undefined variable $a in %s on line %d
+
+Notice: Indirect modification of overloaded property A::$x has no effect in %s on line %d
+
+Fatal error: Uncaught Error: Cannot assign by reference to overloaded object in %s:%d
+Stack trace:
+#0 %s(%d): A->__get('p')
+#1 {main}
+  thrown in %s on line %d
diff '--color=auto' -Naur php-8.4.18/Zend/tests/lazy_objects/gh20875.phpt php-8.4.20RC1/Zend/tests/lazy_objects/gh20875.phpt
--- php-8.4.18/Zend/tests/lazy_objects/gh20875.phpt	1970-01-01 00:00:00.000000000 +0000
+++ php-8.4.20RC1/Zend/tests/lazy_objects/gh20875.phpt	2026-04-01 04:35:35.984172899 +0000
@@ -0,0 +1,49 @@
+--TEST--
+GH-20875 (Assertion failure in _get_zval_ptr_tmp with lazy proxy)
+--FILE--
+<?php
+class A {
+    public $_;
+    public function __get($name) {
+        global $obj;
+        $obj->f =& $this->b - $x > $y = new StdClass;
+        static $a = $a;
+        $t = 'x';
+        foreach (get_defined_vars() as $key => $e) {}
+        if ($v ==!1) $x = $a ?: $t = "ok";
+    }
+}
+$rc = new ReflectionClass(A::class);
+$obj = $rc->newLazyProxy(function () { return new A; });
+$real = $rc->initializeLazyObject($obj);
+var_dump($real->prop);
+?>
+--EXPECTF--
+Deprecated: Creation of dynamic property A::$b is deprecated in %s on line %d
+
+Deprecated: Creation of dynamic property A::$f is deprecated in %s on line %d
+
+Warning: Undefined variable $x in %s on line %d
+
+Notice: Object of class stdClass could not be converted to int in %s on line %d
+
+Warning: Undefined variable $a in %s on line %d
+
+Warning: Undefined variable $v in %s on line %d
+
+Notice: Indirect modification of overloaded property A::$b has no effect in %s on line %d
+
+Warning: Undefined variable $x in %s on line %d
+
+Notice: Object of class stdClass could not be converted to int in %s on line %d
+
+Warning: Undefined variable $v in %s on line %d
+
+Notice: Indirect modification of overloaded property A::$f has no effect in %s on line %d
+
+Fatal error: Uncaught Error: Cannot assign by reference to overloaded object in %s:%d
+Stack trace:
+#0 %s(%d): A->__get('b')
+#1 %s(%d): A->__get('prop')
+#2 {main}
+  thrown in %s on line %d
diff '--color=auto' -Naur php-8.4.18/Zend/tests/lazy_objects/gh20875_proxy_get_no_init.phpt php-8.4.20RC1/Zend/tests/lazy_objects/gh20875_proxy_get_no_init.phpt
--- php-8.4.18/Zend/tests/lazy_objects/gh20875_proxy_get_no_init.phpt	1970-01-01 00:00:00.000000000 +0000
+++ php-8.4.20RC1/Zend/tests/lazy_objects/gh20875_proxy_get_no_init.phpt	2026-04-01 04:35:35.984249393 +0000
@@ -0,0 +1,23 @@
+--TEST--
+GH-20875 (Lazy proxy should not initialize when __get handles dynamic property access)
+--FILE--
+<?php
+
+class Foo {
+    public $_;
+
+    public function &__get($name) {
+        echo "__get\n";
+        return $name;
+    }
+}
+
+$proxy = (new ReflectionClass(Foo::class))->newLazyProxy(function () {
+    echo "init\n";
+    return new Foo();
+});
+$x = &$proxy->x;
+
+?>
+--EXPECT--
+__get
diff '--color=auto' -Naur php-8.4.18/Zend/tests/oss-fuzz-478009707.phpt php-8.4.20RC1/Zend/tests/oss-fuzz-478009707.phpt
--- php-8.4.18/Zend/tests/oss-fuzz-478009707.phpt	1970-01-01 00:00:00.000000000 +0000
+++ php-8.4.20RC1/Zend/tests/oss-fuzz-478009707.phpt	2026-04-01 04:35:35.984358299 +0000
@@ -0,0 +1,27 @@
+--TEST--
+OSS-Fuzz #478009707: Assign-op/inc/dec on untyped hooked property backing value
+--FILE--
+<?php
+
+class C {
+    public $prop {
+        set {
+            $this->prop = $value;
+            $this->prop += 1;
+            $this->prop++;
+            ++$this->prop;
+        }
+    }
+}
+
+$c = new C(1);
+$c->prop = 1;
+var_dump($c->prop);
+
+$c->prop = PHP_INT_MAX;
+var_dump($c->prop);
+
+?>
+--EXPECTF--
+int(4)
+float(%s)
diff '--color=auto' -Naur php-8.4.18/Zend/zend_call_stack.h php-8.4.20RC1/Zend/zend_call_stack.h
--- php-8.4.18/Zend/zend_call_stack.h	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/Zend/zend_call_stack.h	2026-04-01 04:35:35.984654058 +0000
@@ -21,6 +21,9 @@
 
 #include "zend.h"
 #include "zend_portability.h"
+#ifdef _MSC_VER
+# include <intrin.h>
+#endif
 #ifdef __APPLE__
 # include <pthread.h>
 #endif
diff '--color=auto' -Naur php-8.4.18/Zend/zend.h php-8.4.20RC1/Zend/zend.h
--- php-8.4.18/Zend/zend.h	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/Zend/zend.h	2026-04-01 04:35:59.692545423 +0000
@@ -20,7 +20,7 @@
 #ifndef ZEND_H
 #define ZEND_H
 
-#define ZEND_VERSION "4.4.18"
+#define ZEND_VERSION "4.4.20RC1"
 
 #define ZEND_ENGINE_3
 
diff '--color=auto' -Naur php-8.4.18/Zend/zend_hash.c php-8.4.20RC1/Zend/zend_hash.c
--- php-8.4.18/Zend/zend_hash.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/Zend/zend_hash.c	2026-04-01 04:35:35.984785777 +0000
@@ -169,7 +169,7 @@
 	void *data;
 	uint32_t nSize = ht->nTableSize;
 
-	ZEND_ASSERT(HT_SIZE_TO_MASK(nSize));
+	ZEND_ASSERT(HT_SIZE_TO_MASK(nSize) != 0);
 
 	if (UNEXPECTED(GC_FLAGS(ht) & IS_ARRAY_PERSISTENT)) {
 		data = pemalloc(HT_SIZE_EX(nSize, HT_SIZE_TO_MASK(nSize)), 1);
@@ -351,7 +351,7 @@
 	uint32_t i;
 	uint32_t nSize = ht->nTableSize;
 
-	ZEND_ASSERT(HT_SIZE_TO_MASK(nSize));
+	ZEND_ASSERT(HT_SIZE_TO_MASK(nSize) != 0);
 
 	HT_ASSERT_RC1(ht);
 	// Alloc before assign to avoid inconsistencies on OOM
@@ -399,7 +399,7 @@
 
 	if (nSize == 0) return;
 
-	ZEND_ASSERT(HT_SIZE_TO_MASK(nSize));
+	ZEND_ASSERT(HT_SIZE_TO_MASK(nSize) != 0);
 
 	if (UNEXPECTED(HT_FLAGS(ht) & HASH_FLAG_UNINITIALIZED)) {
 		if (nSize > ht->nTableSize) {
@@ -1318,7 +1318,7 @@
 		uint32_t nSize = ht->nTableSize + ht->nTableSize;
 		Bucket *old_buckets = ht->arData;
 
-		ZEND_ASSERT(HT_SIZE_TO_MASK(nSize));
+		ZEND_ASSERT(HT_SIZE_TO_MASK(nSize) != 0);
 
 		new_data = pemalloc(HT_SIZE_EX(nSize, HT_SIZE_TO_MASK(nSize)), GC_FLAGS(ht) & IS_ARRAY_PERSISTENT);
 		ht->nTableSize = nSize;
diff '--color=auto' -Naur php-8.4.18/Zend/zend.h.orig php-8.4.20RC1/Zend/zend.h.orig
